package Net::DNS::RR::MINFO;

use strict;
use warnings;
our $VERSION = (qw$Id: MINFO.pm 1896 2023-01-30 12:59:25Z willem $)[2];

use base qw(Net::DNS::RR);



use integer;

use Net::DNS::Mailbox;


sub _decode_rdata {			## decode rdata from wire-format octet string
	my ( $self, @argument ) = @_;
	my ( $data, $offset, @opaque ) = @argument;

	( $self->{rmailbx}, $offset ) = Net::DNS::Mailbox1035->decode(@argument);
	( $self->{emailbx}, $offset ) = Net::DNS::Mailbox1035->decode( $data, $offset, @opaque );
	return;
}


sub _encode_rdata {			## encode rdata as wire-format octet string
	my ( $self,   @argument ) = @_;
	my ( $offset, @opaque )	  = @argument;

	my $rdata = $self->{rmailbx}->encode(@argument);
	$rdata .= $self->{emailbx}->encode( $offset + length $rdata, @opaque );
	return $rdata;
}


sub _format_rdata {			## format rdata portion of RR string.
	my $self = shift;

	my @rdata = ( $self->{rmailbx}->string, $self->{emailbx}->string );
	return @rdata;
}


sub _parse_rdata {			## populate RR from rdata in argument list
	my ( $self, @argument ) = @_;

	for (qw(rmailbx emailbx)) { $self->$_( shift @argument ) }
	return;
}


sub rmailbx {
	my ( $self, @value ) = @_;
	for (@value) { $self->{rmailbx} = Net::DNS::Mailbox1035->new($_) }
	return $self->{rmailbx} ? $self->{rmailbx}->address : undef;
}


sub emailbx {
	my ( $self, @value ) = @_;
	for (@value) { $self->{emailbx} = Net::DNS::Mailbox1035->new($_) }
	return $self->{emailbx} ? $self->{emailbx}->address : undef;
}


1;
__END__


