package Net::DNS::Update;

use strict;
use warnings;

our $VERSION = (qw$Id: Update.pm 1895 2023-01-16 13:38:08Z willem $)[2];




use integer;
use Carp;

use base qw(Net::DNS::Packet);

use Net::DNS::Resolver;



sub new {
	my ( $class, $zone, @rrclass ) = @_;

	my ($domain) = grep { defined && length } ( $zone, Net::DNS::Resolver->searchlist );

	my $self = __PACKAGE__->SUPER::new( $domain, 'SOA', @rrclass );

	my $header = $self->header;
	$header->opcode('UPDATE');
	$header->qr(0);
	$header->rd(0);

	return $self;
}



sub push {
	my ( $self, $section, @rr ) = @_;
	my ($zone) = $self->zone;
	my $zclass = $zone->zclass;
	for (@rr) { $_->class( $_->class =~ /ANY|NONE/ ? () : $zclass ) }
	return $self->SUPER::push( $section, @rr );
}



sub unique_push {
	my ( $self, $section, @rr ) = @_;
	my ($zone) = $self->zone;
	my $zclass = $zone->zclass;
	for (@rr) { $_->class( $_->class =~ /ANY|NONE/ ? () : $zclass ) }
	return $self->SUPER::unique_push( $section, @rr );
}


1;

__END__



